"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
/** Log levels defined in RFC5424. */
var ELogLevel;
(function (ELogLevel) {
    ELogLevel[ELogLevel["Emergency"] = 0] = "Emergency";
    ELogLevel[ELogLevel["Alert"] = 1] = "Alert";
    ELogLevel[ELogLevel["Critical"] = 2] = "Critical";
    ELogLevel[ELogLevel["Error"] = 3] = "Error";
    ELogLevel[ELogLevel["Warning"] = 4] = "Warning";
    ELogLevel[ELogLevel["Notice"] = 5] = "Notice";
    ELogLevel[ELogLevel["Informational"] = 6] = "Informational";
    ELogLevel[ELogLevel["Debug"] = 7] = "Debug";
})(ELogLevel = exports.ELogLevel || (exports.ELogLevel = {}));
/** Abstract log class. */
var Log = /** @class */ (function () {
    function Log() {
    }
    /** System is unusable. */
    Log.prototype.emergency = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Emergency, message, metadata], args));
    };
    /** Action must be taken immediately. */
    Log.prototype.alert = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Alert, message, metadata], args));
    };
    /** Critical conditions. */
    Log.prototype.critical = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Critical, message, metadata], args));
    };
    /** Error conditions. */
    Log.prototype.error = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Error, message, metadata], args));
    };
    /** Warning conditions. */
    Log.prototype.warn = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Warning, message, metadata], args));
    };
    /** Normal but significant condition. */
    Log.prototype.notice = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Notice, message, metadata], args));
    };
    /** Informational messages. */
    Log.prototype.info = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Informational, message, metadata], args));
    };
    /** Debug level messages. */
    Log.prototype.debug = function (message, metadata) {
        if (metadata === void 0) { metadata = {}; }
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return this.log.apply(this, __spreadArrays([ELogLevel.Debug, message, metadata], args));
    };
    return Log;
}());
exports.Log = Log;
//# sourceMappingURL=log.js.map