"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Debug = require("debug");
var lodash_1 = require("lodash");
var lodash_2 = require("lodash");
var error_1 = require("../lib/error");
var container_1 = require("./container");
var log_1 = require("./log");
var metric_1 = require("./metric");
/** Module error codes. */
var EModuleError;
(function (EModuleError) {
    EModuleError["Dependency"] = "ModuleError.Dependency";
})(EModuleError = exports.EModuleError || (exports.EModuleError = {}));
/** Module error class. */
var ModuleError = /** @class */ (function (_super) {
    __extends(ModuleError, _super);
    function ModuleError(code, cause, context) {
        return _super.call(this, { name: "ModuleError", value: __assign({ code: code }, context) }, cause) || this;
    }
    return ModuleError;
}(error_1.ErrorChain));
exports.ModuleError = ModuleError;
/** Container module log class. */
var ModuleLog = /** @class */ (function (_super) {
    __extends(ModuleLog, _super);
    function ModuleLog(container, namespace) {
        var _this = _super.call(this) || this;
        _this.container = container;
        _this.namespace = namespace;
        return _this;
    }
    /**
     * Sends log message to container bus for consumption by modules.
     * Adds module namespace to metadata object by default.
     */
    ModuleLog.prototype.log = function (level, message, metadata) {
        var args = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            args[_i - 3] = arguments[_i];
        }
        metadata.moduleNamespace = this.namespace;
        this.container.sendLog(level, message, metadata, args);
    };
    return ModuleLog;
}(log_1.Log));
exports.ModuleLog = ModuleLog;
/** Container module metric class. */
var ModuleMetric = /** @class */ (function (_super) {
    __extends(ModuleMetric, _super);
    function ModuleMetric(container, namespace) {
        var _this = _super.call(this) || this;
        _this.container = container;
        _this.namespace = namespace;
        return _this;
    }
    /**
     * Sends metric message to container bus for consumption by modules.
     * Adds module namespace to tags object by default.
     */
    ModuleMetric.prototype.metric = function (type, name, value, tags) {
        var args = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            args[_i - 4] = arguments[_i];
        }
        tags.moduleNamespace = this.namespace;
        this.container.sendMetric(type, name, value, tags, args);
    };
    return ModuleMetric;
}(metric_1.Metric));
exports.ModuleMetric = ModuleMetric;
/** Base class for container class modules with dependency injection. */
var Module = /** @class */ (function () {
    function Module(options) {
        var _this = this;
        // Resolve container instance and construct instance properties.
        this.moduleName = options.moduleName;
        this.container = options.opts[container_1.EContainerScope.Container];
        this.log = new ModuleLog(this.container, this.namespace);
        this.metric = new ModuleMetric(this.container, this.namespace);
        this.debug = Debug(this.namespace);
        // Inject dependency values into instance.
        // Error is thrown by awilix if resolution failed.
        try {
            var dependencies_1 = this.moduleDependencies();
            lodash_1.keys(dependencies_1).map(function (key) {
                var target = dependencies_1[key];
                _this[key] = options.opts[target.moduleName];
            });
        }
        catch (error) {
            throw new ModuleError(EModuleError.Dependency, error);
        }
    }
    Object.defineProperty(Module.prototype, "environment", {
        /** Module container environment reference. */
        get: function () {
            return this.container.environment;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "namespace", {
        /** Module container and module names. */
        get: function () {
            return this.container.name + "." + this.moduleName;
        },
        enumerable: true,
        configurable: true
    });
    /** Module dependencies hook. */
    Module.prototype.moduleDependencies = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return lodash_1.assign.apply(void 0, __spreadArrays([{}], args));
    };
    /** Module operational state hook. */
    Module.prototype.moduleUp = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, hook;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = 0, _b = lodash_2.reverse(args.slice());
                        _c.label = 1;
                    case 1:
                        if (!(_a < _b.length)) return [3 /*break*/, 4];
                        hook = _b[_a];
                        return [4 /*yield*/, hook()];
                    case 2:
                        _c.sent();
                        _c.label = 3;
                    case 3:
                        _a++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /** Module non-operational state hook. */
    Module.prototype.moduleDown = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var _a, args_1, hook;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = 0, args_1 = args;
                        _b.label = 1;
                    case 1:
                        if (!(_a < args_1.length)) return [3 /*break*/, 4];
                        hook = args_1[_a];
                        return [4 /*yield*/, hook()];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        _a++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /** Module destruction hook. */
    Module.prototype.moduleDestroy = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.map(function (hook) { return hook(); });
    };
    /** Default module name. */
    Module.moduleName = "Module";
    return Module;
}());
exports.Module = Module;
//# sourceMappingURL=module.js.map