"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
var util_1 = require("util");
var container_1 = require("../../../container");
var error_1 = require("../../error");
var validate_1 = require("../validate");
/** Assets log names. */
var EAssetsLog;
(function (EAssetsLog) {
    EAssetsLog["Information"] = "Assets.Information";
})(EAssetsLog = exports.EAssetsLog || (exports.EAssetsLog = {}));
/** Assets error codes. */
var EAssetsError;
(function (EAssetsError) {
    EAssetsError["ReadFile"] = "AssetsError.ReadFile";
    EAssetsError["JsonParse"] = "AssetsError.JsonParse";
    EAssetsError["ReadDirectory"] = "AssetsError.ReadDirectory";
})(EAssetsError = exports.EAssetsError || (exports.EAssetsError = {}));
/** Assets error class. */
var AssetsError = /** @class */ (function (_super) {
    __extends(AssetsError, _super);
    function AssetsError(code, cause, context) {
        return _super.call(this, { name: "AssetsError", value: __assign({ code: code }, context) }, cause) || this;
    }
    return AssetsError;
}(error_1.ErrorChain));
exports.AssetsError = AssetsError;
/** Assets environment variable names. */
var EAssetsEnv;
(function (EAssetsEnv) {
    /** Assets directory path (required). */
    EAssetsEnv["Path"] = "ASSETS_PATH";
})(EAssetsEnv = exports.EAssetsEnv || (exports.EAssetsEnv = {}));
/** Assets read only files module. */
var Assets = /** @class */ (function (_super) {
    __extends(Assets, _super);
    function Assets() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /** Absolute path to assets files directory. */
        _this.envPath = validate_1.isDirectory(_this.environment.get(EAssetsEnv.Path));
        /** Internal assets cache. */
        _this.assetsCache = {};
        return _this;
    }
    Assets.prototype.moduleUp = function () {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return _super.prototype.moduleUp.apply(this, __spreadArrays(args, [function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.log.debug(EAssetsLog.Information, { path: this.envPath });
                    return [2 /*return*/];
                });
            }); }]));
    };
    /** Returns true if target file is cached. */
    Assets.prototype.isCached = function (target, encoding) {
        var cacheKey = target + ":" + encoding;
        return this.assetsCache[cacheKey] != null;
    };
    /**
     * Read asset file contents.
     * If encoding is specified a string is returned, else a Buffer.
     */
    Assets.prototype.readFile = function (target, options) {
        if (options === void 0) { options = { cache: true }; }
        return this.assetsRead(target, options);
    };
    /** Read asset file contents and parse JSON object. */
    Assets.prototype.readJson = function (target, options) {
        if (options === void 0) { options = { encoding: "utf8", cache: true }; }
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetsRead(target, options)];
                    case 1:
                        data = (_a.sent());
                        try {
                            return [2 /*return*/, JSON.parse(data)];
                        }
                        catch (error) {
                            throw new AssetsError(EAssetsError.JsonParse, error, { target: target });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /** Read contents of assets directory. */
    Assets.prototype.readDirectory = function (target) {
        if (target === void 0) { target = ""; }
        return __awaiter(this, void 0, void 0, function () {
            var directoryPath, fsReaddir, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        directoryPath = validate_1.isDirectory(path_1.resolve(this.envPath, target));
                        fsReaddir = util_1.promisify(fs_1.readdir);
                        return [4 /*yield*/, fsReaddir(directoryPath)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        error_2 = _a.sent();
                        throw new AssetsError(EAssetsError.ReadDirectory, error_2, { target: target });
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Assets.prototype.assetsRead = function (target, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var cacheKey, filePath, fsReadFile, data, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cacheKey = target + ":" + options.encoding;
                        if (!!options.cache) {
                            if (this.assetsCache[cacheKey] != null) {
                                return [2 /*return*/, this.assetsCache[cacheKey]];
                            }
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        filePath = validate_1.isFile(path_1.resolve(this.envPath, target));
                        fsReadFile = util_1.promisify(fs_1.readFile);
                        return [4 /*yield*/, fsReadFile(filePath, options.encoding)];
                    case 2:
                        data = _a.sent();
                        // Save to cache if enabled in options.
                        if (!!options.cache) {
                            this.assetsCache[cacheKey] = data;
                        }
                        return [2 /*return*/, data];
                    case 3:
                        error_3 = _a.sent();
                        throw new AssetsError(EAssetsError.ReadFile, error_3, { target: target });
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /** Default module name. */
    Assets.moduleName = "Assets";
    return Assets;
}(container_1.Module));
exports.Assets = Assets;
//# sourceMappingURL=assets.js.map