"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var os = require("os");
var process = require("process");
var rxjs_1 = require("rxjs");
var container_1 = require("../../../container");
var error_1 = require("../../error");
var validate_1 = require("../validate");
/** Process error codes. */
var EProcessError;
(function (EProcessError) {
    EProcessError["Signal"] = "ProcessError.Signal";
})(EProcessError = exports.EProcessError || (exports.EProcessError = {}));
/** Process error class. */
var ProcessError = /** @class */ (function (_super) {
    __extends(ProcessError, _super);
    function ProcessError(code, cause, context) {
        return _super.call(this, { name: "ProcessError", value: __assign({ code: code }, context) }, cause) || this;
    }
    return ProcessError;
}(error_1.ErrorChain));
exports.ProcessError = ProcessError;
/** Process environment variable names. */
var EProcessEnv;
(function (EProcessEnv) {
    EProcessEnv["Name"] = "PROCESS_NAME";
    EProcessEnv["Version"] = "PROCESS_VERSION";
    EProcessEnv["NodeEnv"] = "NODE_ENV";
})(EProcessEnv = exports.EProcessEnv || (exports.EProcessEnv = {}));
/** Process log names. */
var EProcessLog;
(function (EProcessLog) {
    EProcessLog["Information"] = "Process.Information";
    EProcessLog["Signal"] = "Process.Signal";
})(EProcessLog = exports.EProcessLog || (exports.EProcessLog = {}));
/** Process metric names. */
var EProcessMetric;
(function (EProcessMetric) {
    EProcessMetric["UserCpuUsage"] = "Process.UserCpuUsage";
    EProcessMetric["SystemCpuUsage"] = "Process.SystemCpuUsage";
    EProcessMetric["RssMemoryUsage"] = "Process.RssMemoryUsage";
    EProcessMetric["HeapTotalMemoryUsage"] = "Process.HeapTotalMemoryUsage";
    EProcessMetric["HeapUsedMemoryUsage"] = "Process.HeapUsedMemoryUsage";
})(EProcessMetric = exports.EProcessMetric || (exports.EProcessMetric = {}));
/** Node.js process interface. */
var Process = /** @class */ (function (_super) {
    __extends(Process, _super);
    function Process(options) {
        var _this = _super.call(this, options) || this;
        _this.envVersion = validate_1.isString(_this.environment.get(EProcessEnv.Version, "1.0.0"));
        _this.envNodeEnv = validate_1.isString(_this.environment.get(EProcessEnv.NodeEnv, "production"));
        // Set process title.
        Process.setTitle(validate_1.isString(_this.environment.get(EProcessEnv.Name, "node")));
        // Process metrics on interval.
        rxjs_1.interval(_this.metricInterval).subscribe(function () { return _this.processMetrics(_this.status); });
        return _this;
    }
    Object.defineProperty(Process, "title", {
        /** Get Node.js process title. */
        get: function () {
            return process.title || "node";
        },
        enumerable: true,
        configurable: true
    });
    /** Set Node.js process title. */
    Process.setTitle = function (name) {
        if (name != null) {
            var untypedProcess = process;
            untypedProcess.title = name;
        }
        return Process.title;
    };
    Object.defineProperty(Process.prototype, "envTitle", {
        get: function () {
            return Process.title;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Process.prototype, "metricInterval", {
        /** Override in subclass to change metric interval. */
        get: function () {
            return 60000;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Process.prototype, "information", {
        /** Get Node.js process information. */
        get: function () {
            return {
                name: this.container.name,
                title: this.envTitle,
                version: this.envVersion,
                environment: this.envNodeEnv,
                arch: process.arch,
                platform: process.platform,
                nodeVersion: process.version,
                pid: process.pid,
                type: os.type(),
                release: os.release(),
                endianness: os.endianness(),
                hostname: os.hostname()
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Process.prototype, "status", {
        /** Get Node.js process status. */
        get: function () {
            return {
                uptime: process.uptime(),
                cpuUsage: process.cpuUsage(),
                memoryUsage: process.memoryUsage()
            };
        },
        enumerable: true,
        configurable: true
    });
    /** Try to read process information asset file, handle process events. */
    Process.prototype.moduleUp = function () {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return _super.prototype.moduleUp.apply(this, __spreadArrays(args, [function () { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    // Log process information.
                    this.log.debug(EProcessLog.Information, this.information);
                    // Process end signal handlers.
                    process.on("SIGTERM", function () { return _this.processOnSignal("SIGTERM"); });
                    process.on("SIGINT", function () { return _this.processOnSignal("SIGINT"); });
                    return [2 /*return*/];
                });
            }); }]));
    };
    /** Kill this process with "SIGINT" signal. */
    Process.prototype.kill = function () {
        process.kill(process.pid, "SIGINT");
    };
    /** Container down when process termination signal received. */
    Process.prototype.processOnSignal = function (signal) {
        return __awaiter(this, void 0, void 0, function () {
            var error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.log.notice(EProcessLog.Signal, { signal: signal });
                        return [4 /*yield*/, this.container.down()];
                    case 1:
                        _a.sent();
                        this.container.destroy();
                        process.exit(0);
                        return [3 /*break*/, 3];
                    case 2:
                        error_2 = _a.sent();
                        // Write error to stderr and exit with error code.
                        error_2 = new ProcessError(EProcessError.Signal, error_2, { signal: signal });
                        process.stderr.write(error_2 + "\n");
                        this.container.destroy();
                        process.exit(1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Process.prototype.processMetrics = function (status) {
        this.metric.gauge(EProcessMetric.UserCpuUsage, status.cpuUsage.user);
        this.metric.gauge(EProcessMetric.SystemCpuUsage, status.cpuUsage.system);
        this.metric.gauge(EProcessMetric.RssMemoryUsage, status.memoryUsage.rss);
        this.metric.gauge(EProcessMetric.HeapTotalMemoryUsage, status.memoryUsage.heapTotal);
        this.metric.gauge(EProcessMetric.HeapUsedMemoryUsage, status.memoryUsage.heapUsed);
    };
    /** Default module name. */
    Process.moduleName = "Process";
    return Process;
}(container_1.Module));
exports.Process = Process;
//# sourceMappingURL=process.js.map