"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validate_1 = require("../../validate");
var validate_2 = require("../validate");
/** Validate that value is a valid Node.js Buffer. */
function isBuffer(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    try {
        var buf = Buffer.from(value, options.encoding);
        if (buf == null) {
            throw new validate_2.NodeValidateError(validate_2.ENodeValidateError.IsBufferError, value);
        }
        return buf;
    }
    catch (error) {
        throw new validate_2.NodeValidateError(validate_2.ENodeValidateError.IsBufferError, value, error);
    }
}
exports.isBuffer = isBuffer;
var BufferField = /** @class */ (function (_super) {
    __extends(BufferField, _super);
    function BufferField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    BufferField.prototype.validate = function (value) {
        return isBuffer(value, this.options);
    };
    BufferField.prototype.format = function (value) {
        return value.toString(this.options.encoding);
    };
    return BufferField;
}(validate_1.Field));
exports.BufferField = BufferField;
//# sourceMappingURL=is-buffer.js.map