import { ErrorChain } from "../error";
/** Validate error codes. */
export declare enum EValidateError {
    IsAlphaError = 0,
    IsAlphanumericError = 1,
    IsAsciiError = 2,
    IsBase64Error = 3,
    IsBooleanError = 4,
    IsCountryError = 5,
    IsCreditCardError = 6,
    IsDateTimeError = 7,
    IsDomainError = 8,
    IsDurationError = 9,
    IsEmailError = 10,
    IsFloatError = 11,
    IsHashError = 12,
    IsHexColourError = 13,
    IsHexadecimalError = 14,
    IsIntegerError = 15,
    IsIntervalError = 16,
    IsIpError = 17,
    IsJsonError = 18,
    IsLanguageError = 19,
    IsLatitudeLongitudeError = 20,
    IsLocaleError = 21,
    IsMacAddressError = 22,
    IsMimeTypeError = 23,
    IsMobilePhoneError = 24,
    IsMongoIdError = 25,
    IsPortError = 26,
    IsPostalCodeError = 27,
    IsStringError = 28,
    IsTimeZoneError = 29,
    IsUrlError = 30,
    IsUuidError = 31
}
/** Validate error chain class. */
export declare class ValidateError extends ErrorChain {
    constructor(code: EValidateError, value?: any, cause?: Error);
}
