"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
var is_string_1 = require("./is-string");
/** Wrapper for validator isAlpha. */
function isAlpha(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    var locale = options.locale || "en-GB";
    try {
        if (validator_1.default.isAlpha(value, locale) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsAlphaError, value);
        }
        return is_string_1.isString(value, options);
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsAlphaError, value, error);
    }
}
exports.isAlpha = isAlpha;
var AlphaField = /** @class */ (function (_super) {
    __extends(AlphaField, _super);
    function AlphaField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    AlphaField.prototype.validate = function (value) {
        return isAlpha(value, this.options);
    };
    return AlphaField;
}(field_1.Field));
exports.AlphaField = AlphaField;
//# sourceMappingURL=is-alpha.js.map