import validator from "validator";
import { Field } from "../field";
import { IIsString } from "./is-string";
/** Validate.isAlphanumeric options. */
export interface IIsAlphanumeric extends IIsString {
    /** Locale used by validator, defaults to en-GB. */
    locale?: validator.AlphanumericLocale;
}
/** Wrapper for validator isAlphanumeric. */
export declare function isAlphanumeric(value?: string, options?: IIsAlphanumeric): string;
export declare class AlphanumericField extends Field<string> {
    protected readonly options: IIsAlphanumeric;
    constructor(options?: IIsAlphanumeric);
    validate(value: string): string;
}
