"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
var is_string_1 = require("./is-string");
/** Wrapper for validator isBase64. */
function isBase64(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    try {
        if (validator_1.default.isBase64(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsBase64Error, value);
        }
        return is_string_1.isString(value, options);
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsBase64Error, value, error);
    }
}
exports.isBase64 = isBase64;
var Base64Field = /** @class */ (function (_super) {
    __extends(Base64Field, _super);
    function Base64Field(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    Base64Field.prototype.validate = function (value) {
        return isBase64(value, this.options);
    };
    return Base64Field;
}(field_1.Field));
exports.Base64Field = Base64Field;
//# sourceMappingURL=is-base64.js.map