"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator toBoolean. */
function isBoolean(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    var strict = !!options.strict;
    try {
        return validator_1.default.toBoolean(value, strict);
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsBooleanError, value, error);
    }
}
exports.isBoolean = isBoolean;
var BooleanField = /** @class */ (function (_super) {
    __extends(BooleanField, _super);
    function BooleanField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    BooleanField.prototype.validate = function (value) {
        return isBoolean(value, this.options);
    };
    return BooleanField;
}(field_1.Field));
exports.BooleanField = BooleanField;
//# sourceMappingURL=is-boolean.js.map