"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var luxon_1 = require("luxon");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Validate that value is a valid date and time parsed by 'luxon' library. */
function isDateTime(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    options.zone = options.zone || "UTC";
    try {
        var datetime = luxon_1.DateTime.fromISO(value, options);
        if (datetime.isValid !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsDateTimeError, value);
        }
        return datetime;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsDateTimeError, value, error);
    }
}
exports.isDateTime = isDateTime;
var DateTimeField = /** @class */ (function (_super) {
    __extends(DateTimeField, _super);
    function DateTimeField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    DateTimeField.prototype.validate = function (value) {
        return isDateTime(value, this.options);
    };
    DateTimeField.prototype.format = function (value) {
        return value.toISO();
    };
    return DateTimeField;
}(field_1.Field));
exports.DateTimeField = DateTimeField;
//# sourceMappingURL=is-date-time.js.map