"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var luxon_1 = require("luxon");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Validate that value is a valid duration parsed by 'luxon' library. */
function isDuration(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    try {
        var duration = luxon_1.Duration.fromISO(value, options);
        if (duration.isValid !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsDurationError, value);
        }
        return duration;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsDurationError, value, error);
    }
}
exports.isDuration = isDuration;
var DurationField = /** @class */ (function (_super) {
    __extends(DurationField, _super);
    function DurationField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    DurationField.prototype.validate = function (value) {
        return isDuration(value, this.options);
    };
    DurationField.prototype.format = function (value) {
        return value.toISO();
    };
    return DurationField;
}(field_1.Field));
exports.DurationField = DurationField;
//# sourceMappingURL=is-duration.js.map