"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator isHexadecimal. */
function isHexadecimal(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isHexadecimal(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsHexadecimalError, value);
        }
        return validator_1.default.toInt(value, 16);
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsHexadecimalError, value, error);
    }
}
exports.isHexadecimal = isHexadecimal;
var HexadecimalField = /** @class */ (function (_super) {
    __extends(HexadecimalField, _super);
    function HexadecimalField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HexadecimalField.prototype.validate = function (value) {
        return isHexadecimal(value);
    };
    HexadecimalField.prototype.format = function (value) {
        return "0x" + value.toString(16);
    };
    return HexadecimalField;
}(field_1.Field));
exports.HexadecimalField = HexadecimalField;
//# sourceMappingURL=is-hexadecimal.js.map