"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var luxon_1 = require("luxon");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Validate that value is a valid date time interval parsed by 'luxon' library. */
function isInterval(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    try {
        var interval = luxon_1.Interval.fromISO(value, options);
        if (interval.isValid !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsIntervalError, value);
        }
        return interval;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsIntervalError, value, error);
    }
}
exports.isInterval = isInterval;
var IntervalField = /** @class */ (function (_super) {
    __extends(IntervalField, _super);
    function IntervalField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    IntervalField.prototype.validate = function (value) {
        return isInterval(value, this.options);
    };
    IntervalField.prototype.format = function (value) {
        return value.toISO();
    };
    return IntervalField;
}(field_1.Field));
exports.IntervalField = IntervalField;
//# sourceMappingURL=is-interval.js.map