"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator isJSON. */
function isJson(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isJSON(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsJsonError, value);
        }
        return JSON.parse(value);
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsJsonError, value, error);
    }
}
exports.isJson = isJson;
var JsonField = /** @class */ (function (_super) {
    __extends(JsonField, _super);
    function JsonField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    JsonField.prototype.validate = function (value) {
        return isJson(value);
    };
    JsonField.prototype.format = function (value) {
        return JSON.stringify(value);
    };
    return JsonField;
}(field_1.Field));
exports.JsonField = JsonField;
//# sourceMappingURL=is-json.js.map