"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var data_1 = require("../data");
var field_1 = require("../field");
var validate_1 = require("../validate");
var is_string_1 = require("./is-string");
/** Validate that value is a valid ISO639 language code. */
function isLanguage(value) {
    if (value === void 0) { value = ""; }
    try {
        return is_string_1.isString(value.toLowerCase(), { min: 2, max: 2, values: data_1.ISO639 });
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsLanguageError, value, error);
    }
}
exports.isLanguage = isLanguage;
var LanguageField = /** @class */ (function (_super) {
    __extends(LanguageField, _super);
    function LanguageField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LanguageField.prototype.validate = function (value) {
        return isLanguage(value);
    };
    return LanguageField;
}(field_1.Field));
exports.LanguageField = LanguageField;
//# sourceMappingURL=is-language.js.map