"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
var is_float_1 = require("./is-float");
/** Wrapper for validator isLatLong. */
function isLatitudeLongitude(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isLatLong(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsLatitudeLongitudeError, value);
        }
        // Split string and trim for parsing as floats.
        var values = value.split(",").map(function (v) { return v.trim(); });
        var latitudeLongitude = {
            latitude: is_float_1.isFloat(values[0]),
            longitude: is_float_1.isFloat(values[1])
        };
        return latitudeLongitude;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsLatitudeLongitudeError, value, error);
    }
}
exports.isLatitudeLongitude = isLatitudeLongitude;
var LatitudeLongitudeField = /** @class */ (function (_super) {
    __extends(LatitudeLongitudeField, _super);
    function LatitudeLongitudeField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LatitudeLongitudeField.prototype.validate = function (value) {
        return isLatitudeLongitude(value);
    };
    LatitudeLongitudeField.prototype.format = function (value) {
        return value.latitude + "," + value.longitude;
    };
    return LatitudeLongitudeField;
}(field_1.Field));
exports.LatitudeLongitudeField = LatitudeLongitudeField;
//# sourceMappingURL=is-latitude-longitude.js.map