"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var field_1 = require("../field");
var validate_1 = require("../validate");
var is_country_1 = require("./is-country");
var is_language_1 = require("./is-language");
/** Validate that value is a valid locale (language_COUNTRY). */
function isLocale(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    var separator = options.separator || "_";
    try {
        var parts = value.split(separator);
        var language = is_language_1.isLanguage(parts[0]);
        var country = is_country_1.isCountry(parts[1]);
        return "" + language + separator + country;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsLocaleError, value, error);
    }
}
exports.isLocale = isLocale;
var LocaleField = /** @class */ (function (_super) {
    __extends(LocaleField, _super);
    function LocaleField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    LocaleField.prototype.validate = function (value) {
        return isLocale(value, this.options);
    };
    return LocaleField;
}(field_1.Field));
exports.LocaleField = LocaleField;
//# sourceMappingURL=is-locale.js.map