"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Validate that value is a valid port number. */
function isPort(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isPort(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsPortError, value);
        }
        return validator_1.default.toInt(value, 10);
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsPortError, value, error);
    }
}
exports.isPort = isPort;
var PortField = /** @class */ (function (_super) {
    __extends(PortField, _super);
    function PortField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PortField.prototype.validate = function (value) {
        return isPort(value);
    };
    return PortField;
}(field_1.Field));
exports.PortField = PortField;
//# sourceMappingURL=is-port.js.map