"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator isPostalCode. */
function isPostalCode(value, options) {
    if (value === void 0) { value = ""; }
    if (options === void 0) { options = {}; }
    var locale = options.locale || "GB";
    try {
        if (validator_1.default.isPostalCode(value, locale) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsPostalCodeError, value);
        }
        return value;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsPostalCodeError, value, error);
    }
}
exports.isPostalCode = isPostalCode;
var PostalCodeField = /** @class */ (function (_super) {
    __extends(PostalCodeField, _super);
    function PostalCodeField(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    PostalCodeField.prototype.validate = function (value) {
        return isPostalCode(value, this.options);
    };
    return PostalCodeField;
}(field_1.Field));
exports.PostalCodeField = PostalCodeField;
//# sourceMappingURL=is-postal-code.js.map