"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var luxon_1 = require("luxon");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Validate that value is a valid time zone supported by 'luxon' library. */
function isTimeZone(value) {
    if (value === void 0) { value = ""; }
    try {
        var datetime = luxon_1.DateTime.local().setZone(value);
        if (datetime.isValid !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsTimeZoneError, value);
        }
        return datetime.zoneName;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsTimeZoneError, value, error);
    }
}
exports.isTimeZone = isTimeZone;
var TimeZoneField = /** @class */ (function (_super) {
    __extends(TimeZoneField, _super);
    function TimeZoneField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TimeZoneField.prototype.validate = function (value) {
        return isTimeZone(value);
    };
    return TimeZoneField;
}(field_1.Field));
exports.TimeZoneField = TimeZoneField;
//# sourceMappingURL=is-time-zone.js.map